/* Arquivo Capitulo_09_03.c */
#include <stdio.h>
#include <stdlib.h>

struct Registro_Carro
{
    char Placa[7];
    char Modelo[30];
    int ano;
    char Cor[30];
};

/* funo para gravar os dados de um vetor de carros num arquivo */
void Grava_Dados(struct Registro_Carro Vetor_Carros[100])
{
    int i;

	/* Declarao de arquivo. "FILE *" faz a funo de "arquivo de " */
    FILE *Id_Arquivo;

    /* testa a abertura do arquivo */
	/* "fopen" corresponde a "abra_arquivo". */
    if((Id_Arquivo = fopen("carros1.dat", "w")) == NULL)
    {
        printf("Problemas na abertura do arquivo de carros para gravar!\n");
        exit(-1);
    }

    i = 0;

    /* Percorre o vetor at encontrar a placa "fim" ou chegarmos ao */
    /* centsimo elemento */
	/*	strcmp - compara strings */
    while (i <= 100 && strcmp(Vetor_Carros[i].Placa,"fim")!=0)
    {
	/* fwrite corresponde a grave_arquivo.  necessrio indicar o tamanho do registro via "sizeof" */
        if(fwrite(&(Vetor_Carros[i]), sizeof(struct Registro_Carro),1, Id_Arquivo)==0)
        {
            printf("Problemas na gravao no arquivo de carros!\n");
            exit(-1);
        }
        i = i + 1;
    }

    /* fecha o arquivo */
	/* "fclose" corresponde ao comando "feche_arquivo" */
    if (fclose(Id_Arquivo)!= 0)
    {
        printf("Problemas no fechamento do arquivo de carros!\n");
        exit(-1);
    }
}

/* funo para ler o vetor de carros */
void Le_Dados(struct Registro_Carro *Vetor_Carros)
{
    int i;
    FILE *Id_Arquivo;
    struct Registro_Carro *Carro;

    /* aloca espao para o vetor de carros */
    Carro = (struct Registro_Carro *) malloc(sizeof(struct Registro_Carro));

    /* testa a abertura do arquivo */
    if((Id_Arquivo = fopen("carros.dat", "r")) == NULL)
    {
        printf("Problemas na abertura do arquivo de carros para leitura!\n");
        exit(-1);
    }

    i = 0;

    /* Percorre o vetor at encontrar fim de arquivo ou chegarmos ao */
    /* centsimo elemento */
    while (i <= 100 && !feof(Id_Arquivo))
    {
/* fread corresponde a leia_arquivo.  necessrio indicar o tamanho do registro via "sizeof" */
        fread(Carro, sizeof(struct Registro_Carro), 1, Id_Arquivo);
        if(ferror(Id_Arquivo))
        {
            printf("Problemas na leitura do arquivo de carros!\n");
            exit(-1);
        }
        else
        {
            /* a leitura foi bem-sucedida */
            Vetor_Carros[i].ano = Carro->ano;
            strcpy(Vetor_Carros[i].Placa, Carro->Placa);
            strcpy(Vetor_Carros[i].Modelo, Carro->Modelo);
            strcpy(Vetor_Carros[i].Cor, Carro->Cor);
        }
        i = i + 1;
    }
    if (fclose(Id_Arquivo)!= 0)
    {
        printf("Problemas no fechamento do arquivo de carros!\n");
        exit(-1);
    }
}

int main()
{
	struct Registro_Carro *Vetor_Carros;
	Vetor_Carros = (struct Registro_Carro *) malloc(100 * sizeof(struct Registro_Carro));
	/* dados de teste */
	/* sprintf(Vetor_Carros[0].Placa, "1234");
	sprintf(Vetor_Carros[0].Modelo, "mustangue");
	sprintf(Vetor_Carros[0].Cor, "verde");
	Vetor_Carros[0].ano = 75;
	sprintf(Vetor_Carros[1].Placa, "755");
	sprintf(Vetor_Carros[1].Modelo, "gol");
	sprintf(Vetor_Carros[1].Cor, "azul");
	Vetor_Carros[1].ano = 1234;
	sprintf(Vetor_Carros[2].Placa, "fim");
	sprintf(Vetor_Carros[2].Modelo, "teste");
	sprintf(Vetor_Carros[2].Cor, "teste");
	Vetor_Carros[2].ano = 0; */

	Le_Dados(Vetor_Carros);
	Grava_Dados(Vetor_Carros);
}
