/* Arquivo Capitulo_10_05.c */
#include <stdio.h>
#include <stdlib.h>

/* Estruturas de dados da lista duplamente encadeada */
/* Registro a ser armazenado */
struct Tp_Registro {
	int chave;
};

/* Ponteiro para tipo Item */
typedef struct Item *Ap_Celula;

/* Item: estrutura de um nodo da lista */
struct Item 
{
	struct Tp_Registro Elemento;
	Ap_Celula Prox, Anterior;
};

/* A lista, com Cabeca, Cauda e Tamanho. */
struct Lista_Dupla_Enc 
{
	Ap_Celula Cabeca, Cauda;
	int tamanho;
};

/* Inicializacao */
void Iniciacao_Dinamica_Dupla(struct Lista_Dupla_Enc *Lista) 
{
/* "malloc" corresponde ao comando "aloque" */
	Lista->Cabeca = (struct Item*) malloc(sizeof(struct Item));
	Lista->Cabeca->Elemento.chave = 0;
	Lista->Cauda = Lista->Cabeca;
	Lista->tamanho = 0;
}

/* Insero */
int Insercao_Dinamica_Dupla(struct Lista_Dupla_Enc *Lista, struct Tp_Registro Novo_Item, int posicao) 
{
	int i;
	Ap_Celula Apontador, Item_Aux; 
	
	if((posicao > Lista->tamanho+1) ||  posicao < 1)
		/* posio < 1  invlida */
		return(-1);		
	
	/* Aloca espao de memria para o novo item */
	Item_Aux = (struct Item *) malloc(sizeof(struct Item));

	/* copia os campos (altere para adaptar  sua estrutura de dados) */
	Item_Aux->Elemento.chave = Novo_Item.chave;

	/* Se a lista estiver vazia */
	if(Lista->tamanho != 0)
	{
		i = 0;
		Apontador = Lista->Cabeca->Prox;
		/* posio > Tamanho + 1  maior que a ltima posicao possvel */
		/* para insero na lista */
		while (i < posicao - 1) 
		{
			i = i + 1;
			Apontador = Apontador->Prox;
		}
		/* Rearranjo dos ponteiros */
		Item_Aux->Prox = Apontador->Prox;		
		Item_Aux->Anterior = Apontador;
		Apontador->Prox = Item_Aux;
		Lista->tamanho = Lista->tamanho + 1;
	}
	else 
	{
		Lista->tamanho = 1;
		Item_Aux->Prox = Item_Aux->Anterior = Item_Aux;
		Lista->Cabeca->Prox = Lista->Cauda = Item_Aux;
		Lista->Cabeca->Anterior = Item_Aux;
	}
	return(0);
}

/* Busca  A implementao  igual  de listas encadeadas, com uma nica */
/* diferena na passagem dos parmetros: esta funo precisa de uma */
/* lista duplamente encadeada. */
 
Ap_Celula Busca_Dinamica_Dupla(struct Lista_Dupla_Enc *Lista, int chave) 
{
	Ap_Celula Ap;

	/* Percorre a lista at o fim */
	for (Ap = Lista->Cabeca->Prox; Ap != Lista->Cabeca; Ap = Ap->Prox) 
		/* se encontrou o elemento, retorna-o */
		if (Ap->Elemento.chave == chave)
		{
			/* colocar aqui os demais campos da sua estrutura de dados */
			/* elemento->Chave = Ap->Elemento.Chave; */
			return(Ap);
		}

/* Caso no ache o elemento, retorna NULL */
/* NULL corresponde a "nulo" */
	return(NULL);
}

/* Remoo  Retorna zero se a remoo for bem-sucedida ou -1 caso o elemento a */
/* remover no esteja na lista. */

int Remocao_Dinamica_Dupla(struct Lista_Dupla_Enc *Lista, int chave) 
{
	int i;
	Ap_Celula Ap, Ap_Remove; 
	struct Tp_Registro Elemento;
	
	/* Como o ultimo elemento da lista tem como prximo a cabea da */
	/* lista, ela  condio de parada para o loop. */
	for (Ap = Lista->Cabeca->Prox; Ap != Lista->Cabeca; Ap = Ap->Prox)
		if (Ap->Elemento.chave == chave) 
		{
			Ap_Remove = Ap->Prox;
			
			/* Ajusta os ponteiros */
			Ap->Prox = Ap->Prox->Prox;
			Ap->Prox->Anterior = Ap;
		
			/* apaga o item */
			free(Ap_Remove);
			Lista->tamanho = Lista->tamanho - 1;		
			/* remoo realizada, retorna sucesso */
			return(0);
		}
		
	/* Se o loop terminou, a remoo no foi possvel, pois o elemento */
	/* no est na lista */
	return(-1);
}

/* Trmino */
void Termino_Dinamica_Dupla(struct Lista_Dupla_Enc *Lista) 
{
	Ap_Celula Ap1, Ap2, Cabeca; 
	
	/* testa primeiro se a lista j no est vazia } */
	if(Lista->tamanho == 0)
		/* sai da funo */
		return;
	/* ap1 ser o iterador na lista. ele comea com o elemento logo aps a cabea. Se a */
	/* lista tiver um s elemento, o loop abaixo  evitado e o nico elemento  apagado */
	Ap1 = Lista->Cabeca->Prox;

	/* percorre a lista a partir da cabea, at chegar no ultimo */
	/* elemento (cujo apontador "Prox" aponta para a cabea da lista */
	while (Ap1 != Lista->Cabeca) 
	{
		Ap2 = Ap1->Prox;
		free(Ap1);
		Ap1 = Ap2;
	}
}

int main()
{
	struct Lista_Dupla_Enc Lista;
	struct Tp_Registro Registro;
	Ap_Celula Item_Teste;

	/* Registro exemplo */
	Registro.chave=12345;

	/* Inicializao da lista */
	Iniciacao_Dinamica_Dupla(&Lista);
	printf("Iniciao bem-sucedida\n");
			
	/* Insero na lista */
	if(Insercao_Dinamica_Dupla(&Lista, Registro, 1) ==0)
		printf("Insero bem-sucedida!\n");
	else
		printf("Problemas na insero!\n");

	/* Busca na lista */
	Item_Teste = Busca_Dinamica_Dupla(&Lista, Registro.chave);
	if(Item_Teste != NULL)
		printf("Busca bem-sucedida!\n");
	
	/* Remoo da lista */
	if(Remocao_Dinamica_Dupla(&Lista, Registro.chave) == 0)
		printf("Remoo bem-sucedida!\n");

	/* Trmino da lista */
	Termino_Dinamica_Dupla(&Lista);
	printf("Lista apagada com sucesso!\n");
}