/* Arquivo Capitulo_11_02.c */
#include <stdio.h>
#include <stdlib.h>
/* Estrutura de dados da rvore binria */
/* item */
struct Item
{
	int  isbn;
	char Autor[50];
	char Titulo[100];				
};
/* Ponteiro para nodo */
typedef struct Nodo * Ap_Nodo; 
/* estrutura nodo */
struct Nodo 
{
	struct Item Livro;
	Ap_Nodo Esquerda, Direita;
};
/* estrutura arvore */
struct Arvore
{
	Ap_Nodo Raiz;
};

/* operaes em rvores */

/* operaes sobre rvores binrias */
/* inicializao */
void Iniciacao(struct Arvore *Arv) {
	Arv->Raiz = NULL;
}

/* insero */
int Insercao(struct Arvore *Arv, struct Item Novo_Livro){
	/* chama o procedimento auxiliar para inserir na arvore */
	return Insercao_Nodo(&(Arv->Raiz), Novo_Livro);
}

/* procedimento auxiliar para insero */
int Insercao_Nodo(Ap_Nodo * Nodo1, struct Item Novo_Livro) {
	/* J est no ponto de insero */
	if (*Nodo1 == NULL) {
		*Nodo1 = (struct Nodo *) malloc(sizeof(struct Nodo));

		(*Nodo1)->Livro.isbn  = Novo_Livro.isbn;
		strcpy((*Nodo1)->Livro.Autor, Novo_Livro.Autor);
		strcpy((*Nodo1)->Livro.Titulo, Novo_Livro.Titulo);
		(*Nodo1)->Esquerda = NULL;
		(*Nodo1)->Direita =NULL;

		return(1);
	}

	/* insere o item  esquerda do nodo atual */
	if (Novo_Livro.isbn < (*Nodo1)->Livro.isbn)  
		return(Insercao_Nodo(&(*Nodo1)->Esquerda, Novo_Livro));
	else
		/* insere o item  direita do nodo atual */
		if (Novo_Livro.isbn > (*Nodo1)->Livro.isbn)
			return(Insercao_Nodo(&(*Nodo1)->Direita, Novo_Livro));
		else /* Registro repetido */
			return(0);
}

/* busca */
int Busca(struct Arvore *Arv, int chave, struct Item *Livro) {
	return Busca_Nodo(Arv->Raiz, chave, Livro);
}

/* busca - procedimento auxiliar */
int Busca_Nodo(Ap_Nodo Nodo1, int chave, struct Item *Livro) {
	/* Elemento No Encontrado */
	if (Nodo1 == NULL) 
		return(-1);

	/* Se o ISBN for maior que o do nodo atual, continua a busca  */
	/* direita desse nodo */
	if (chave > Nodo1->Livro.isbn)  	
		return(Busca_Nodo(Nodo1->Direita, chave, Livro));
	else
		/* Se o ISBN for menor que o do nodo atual, continua a busca  */
		/* esquerda desse nodo */
		if (chave < Nodo1->Livro.isbn)  	
			return(Busca_Nodo(Nodo1->Esquerda, chave, Livro));
		/* Elemento foi encontrado */
		else {
			Livro->isbn = Nodo1->Livro.isbn;
			strcpy(Livro->Autor, Nodo1->Livro.Autor);
			strcpy(Livro->Titulo, Nodo1->Livro.Titulo);
			return(0);
		} /* fim else */
}
 
/* remoo */
int Remove(struct Arvore *Arv, int chave) {
	/* chama o procedimento auxiliar */
	return(Remove_Nodo(Arv->Raiz, chave));
}


/* funo utilizada na remoo de nodo */
void Busca_Nova_Raiz(Ap_Nodo Ap_Copia, struct Nodo ** Ap_Arvore) {
	Ap_Nodo Ap_Remove;

	/* Ap_Cpia aponta para o n a ser removido */
	if ((*Ap_Arvore)->Esquerda != NULL)
		Busca_Nova_Raiz(Ap_Copia, &((*Ap_Arvore)->Esquerda));
	else {
		/* Ao invs de remover, copiamos o contedo da nova raiz no n
		 * que seria removido */
		/*Ap_Copia = (*Ap_Arvore); */
		
		Ap_Remove = (*Ap_Arvore);		

		/* Raiz substituta j copiada para sua nova posio */
		Ap_Copia->Livro.isbn = Ap_Remove->Livro.isbn;
		strcpy(Ap_Copia->Livro.Autor, Ap_Remove->Livro.Autor);
		strcpy(Ap_Copia->Livro.Titulo, Ap_Remove->Livro.Titulo);
		
		/* ligao do filho do n liberado com o seu pai. Ap_rvore
		 * foi passado por referncia */
		*Ap_Arvore = (*Ap_Arvore)->Direita;
		
		free(Ap_Remove);
		return;
	}
}

/* procedimento auxiliar para remoo do nodo */
int Remove_Nodo(Ap_Nodo Nodo1, int chave) {
	Ap_Nodo Ap_Aux;
	
	/* Elemento No Encontrado */
	if (Nodo1 == NULL)
		return(0);
	
	/* se o ISBN for maior que o do nodo atual, continua a busca  */
	/* direita desse nodo */
	if (chave > Nodo1->Livro.isbn)  	
		return(Remove_Nodo(Nodo1->Direita, chave));
	else
		/* se o ISBN for maior que o do nodo atual, continua a busca  */
		/* direita desse nodo */
		if(chave < Nodo1->Livro.isbn)
			return(Remove_Nodo(Nodo1->Esquerda, chave));
		/* Elemento Encontrado */
		else {
			Ap_Aux = Nodo1; 
			/* Tipos 1 e 2 */
			if (Nodo1->Direita == NULL){
				Nodo1 = Nodo1->Esquerda;
				free(Ap_Aux);
			}
			else
				/* Tipos 1 e 2 */
				if(Nodo1->Esquerda == NULL){
					Nodo1 = Nodo1->Direita;
					free(Ap_Aux);
				}
				/* Tipo 3 */
				else
					Busca_Nova_Raiz(Nodo1, &(Nodo1->Direita));
			return(1);
	}
}


/* percorre a rvore em percurso ps-ordem, apagando as sub-rvores e
 * depois apagando o n. */
void Apaga_Nodos(Ap_Nodo Nodo1) {
	if(Nodo1 != NULL) {
		Apaga_Nodos(Nodo1->Esquerda);
		Apaga_Nodos(Nodo1->Direita);
		free(Nodo1);
	}
}


/* trmino */
void Termino(struct Arvore Arv) {
	Apaga_Nodos(Arv.Raiz);
}


/* funo para atualizar um registro em uma rvore */
void Atualiza_Registro(struct Arvore *Arv, struct Item Livro) 
{
	Ap_Nodo Nodo1;
	int achou;
	if (Arv->Raiz == NULL) 
	{
		printf("A rvore est vazia!\n");
		return;
	}
	/* A varivel "achou" indica se o elemento foi encontrado na rvore ou no. */
	achou = 0;
	Nodo1 = Arv->Raiz;
	/* Enquanto no achou o elemento ou no chegamos ao fundo da rvore */
	while(!achou && Nodo1!= NULL) 
	{
		if(Livro.isbn == Nodo1->Livro.isbn)
			/* Achamos o elemento na raiz da subrvore atual. */
			achou = 1;
		else
			/* Item est  esquerda da raiz da subrvore atual. */
			if(Livro.isbn < Nodo1->Livro.isbn)
				Nodo1 = Nodo1->Esquerda;
			else 
				Nodo1 = Nodo1->Direita;
	}
	if(!achou)
	{
		printf("No foi encontrado tal registro na rvore!\n");
		return;
	}
	/* Como Nodo1  um ponteiro para o n correto na rvore, basta atualizar as */
	/* informaes diretamente nele que elas constaro na rvore. Em C no  */
	/* possvel fazer a cpia direta de strings. Deve-se usar a funo strcpy. */
	strcpy(Nodo1->Livro.Autor, Livro.Autor);
	strcpy(Nodo1->Livro.Titulo, Livro.Titulo);
}

/* funo principal */
main() {
	struct Arvore Arvore1;
	struct Item Livro;

	Livro.isbn=1234;
	sprintf(Livro.Autor, "Jose");
	sprintf(Livro.Titulo, "Livro do Jose");
	
	/* inicializa a rvore */
	Iniciacao(&Arvore1);

	/* insere o elemento na rvore */
	Insercao(&Arvore1, Livro);

	/* imprime os valores originais */
	printf("%d, ", Arvore1.Raiz->Livro.isbn);
	printf("%s, ", Arvore1.Raiz->Livro.Autor);
	printf("%s\n", Arvore1.Raiz->Livro.Titulo);

	/* troca os valores do livro */
	sprintf(Livro.Autor, "Joao");
	sprintf(Livro.Titulo, "Livro do Joao");
	
	Atualiza_Registro(&Arvore1, Livro);

	/* imprime os valores depois da substituio */
	printf("%d, ", Arvore1.Raiz->Livro.isbn);
	printf("%s, ", Arvore1.Raiz->Livro.Autor);
	printf("%s\n", Arvore1.Raiz->Livro.Titulo);
			
	Termino(Arvore1);
}
