{ Arquivo Capitulo_10_05.pas }
program Lista_Duplamente_Encadeada(Input, Output);

{ Estruturas de dados da lista duplamente encadeada}
type
	{ Registro a ser armazenado}
	Tp_Registro = record
		chave: integer;
	end;
	{ Ponteiro para tipo Item. O smbolo '^'  usado ao invs de '*' }
	Ap_Celula = ^Item;
	{ Item: estrutura de um nodo da lista }
	Item = record
		Elemento: Tp_Registro;
		Prox, Anterior: Ap_Celula;
	end;
	{ A lista, com Cabea, Cauda e Tamanho.}
	Lista_Dupla_Enc = record
		Cabeca, Cauda: Ap_Celula;
		tamanho: integer;
	end;

{ Procedimentos }
{ Inicializao }
procedure Iniciacao_Dinamica_Dupla(var Lista: Lista_Dupla_Enc);
begin
	{ 'nil' corresponde a 'nulo' }
	new(Lista.Cabeca);
	Lista.Cabeca^.Elemento.chave := 0;
	Lista.Cauda := Lista.Cabeca;
	Lista.tamanho := 0;
end;

{ Insero }
function Insercao_Dinamica_Dupla(var Lista: Lista_Dupla_Enc; Novo_Item: Tp_Registro; posicao: integer): boolean;
var
	i: integer;
	Apontador, Item_Aux: Ap_Celula;
begin
	{ posio > Tamanho + 1  maior que a ltima posio possvel
	para insero na lista }
	if (posicao > Lista.tamanho + 1) or (posicao < 1) then
	begin
		{ posio < 1  invlida }
		Insercao_Dinamica_Dupla := false;
		exit;
	end;
	{ Aloca espao de memria para o novo item}
	{ 'new' corresponde ao comando 'aloque' }
	new(Item_Aux);
	{ copia os campos (altere para adaptar  sua estrutura de dados) }
	{ '^.' corresponde a '->' }
	Item_Aux^.Elemento.chave := Novo_Item.chave;
	{ Se a lista no estiver vazia}
	if Lista.tamanho <> 0 then
	begin
		i := 0;
		Apontador := Lista.Cabeca^.Prox;
		while (i < posicao-1) do
		begin
			i := i+1;
			Apontador := Apontador^.Prox;
		end;
		{ Rearranjo dos ponteiros }
		Item_Aux^.Prox := Apontador^.Prox;		
		Item_Aux^.Anterior := Apontador;
		Apontador^.Prox := Item_Aux;
		Lista.tamanho := Lista.tamanho + 1;
	end
	else { lista vazia }
	begin
		Lista.tamanho := 1;
		Item_Aux^.Prox := Item_Aux;
		Item_Aux^.Anterior := Item_Aux;
		Lista.Cabeca^.Prox := Item_Aux;
		Lista.Cabeca^.Anterior := Item_Aux;
		Lista.Cauda := Item_Aux;
	end;
	Insercao_Dinamica_Dupla := true;
end;

{ Busca  A implementao  igual  de listas encadeadas, com uma nica diferena na passagem dos parmetros: esta funo precisa de uma lista duplamente encadeada. A funo ficaria assim: }

function Busca_Dinamica_Dupla(var Lista: Lista_Dupla_Enc; chave:integer):Ap_Celula;
var
	Ap: Ap_Celula;
begin
	{ Percorre a lista at o fim }
	Ap := Lista.Cabeca^.Prox;
	while Ap^.Prox <> Lista.Cabeca do
	begin
		{ se encontrou o elemento, retorna-o}
		if Ap^.Elemento.chave = chave then
		begin
			Busca_Dinamica_Dupla := Ap;
			exit;
		end;
		Ap := Ap^.Prox;
	end;
	{ Caso no ache o elemento, retorna nil}
	Busca_Dinamica_Dupla := nil;
end;

{ Remoo  Retorna True se a operao for bem-sucedida ou False caso haja algum erro }
function Remocao_Dinamica_Dupla(var Lista: Lista_Dupla_Enc; chave:integer): boolean;
var
	Ap, Ap_Remove: Ap_Celula;
	{Elemento: Tp_Registro;}
begin
	Ap := Lista.Cabeca^.Prox;
	{ percorre a lista at chegar ao fim dela - ou seja, o prximo
	elemento  a cabea da lista }
	while Ap^.Prox <> Lista.Cabeca do
	begin
		if (Ap^.Elemento.chave = chave) then
		begin
			Ap_Remove := Ap^.Prox;
			{ Ajusta os ponteiros }
			Ap^.Prox := Ap^.Prox^.Prox;
			Ap^.Prox^.Anterior := Ap;
		
			{ apaga o item }
			dispose(Ap_Remove);
			Lista.tamanho := Lista.tamanho - 1;		
			{ remoo realizada, retorna sucesso }
			Remocao_Dinamica_Dupla := true;
			exit;
		end;
		{ Avana um ponteiro para a frente }
		Ap := Ap^.Prox;
	end;
	{ Remoo no foi possvel pois o elemento no est na lista }
	Remocao_Dinamica_Dupla := false;
end;

{ Trmino }
procedure Termino_Dinamica_Dupla(var Lista: Lista_Dupla_Enc);
var
	Ap1, Ap2: Ap_Celula;
begin
	{ testa primeiro se a lista j no est vazia }
	if Lista.tamanho = 0 then
		{ sai da funo }
		exit;
	{ ap1 ser o iterador na lista; comea com o elemento logo
	aps a cabea. Se a lista tiver um s elemento, o lao abaixo 
	evitado e o nico elemento  apagado }
	Ap1 := Lista.Cabeca^.Prox;
	{ percorre a lista a partir da cabea, at chegar no ltimo
	elemento (cujo apontador 'Prox' aponta para a cabea da lista) }
	while (Ap1 <> Lista.Cabeca) do
	begin
		Ap2 := Ap1^.Prox;
		{ o comando 'dispose' corresponde ao comando 'libere' }
		dispose(Ap1);
		Ap1 := Ap2;
	end;
end;
var
	Lista: Lista_Dupla_Enc;
	Registro: Tp_Registro;
	Item_Teste: Ap_Celula;

{ Programa principal }
begin
	{ Registro exemplo}
	Registro.chave:=12345;

	{ Inicializao da lista }
	Iniciacao_Dinamica_Dupla(Lista);
	writeln('Iniciao bem-sucedida');		
	{ Insero na lista }
	if (Insercao_Dinamica_Dupla(Lista, Registro, 1)) then
		writeln('Insero bem-sucedida!')
	else
		writeln('Problemas na insero!');
	{ Busca na lista }
	Item_Teste := Busca_Dinamica_Dupla(Lista, Registro.chave);
	if (Item_Teste <> nil) then
		writeln('Busca bem-sucedida! Dados: ', Item_Teste^.Elemento.chave);
	{ Remoo da lista }
	if Remocao_Dinamica_Dupla(Lista, Registro.chave) then
		writeln('Remoo bem-sucedida!');
	{ Trmino da lista }
	Termino_Dinamica_Dupla(Lista);
	writeln('Lista apagada com sucesso!');
end.
