{ Arquivo Capitulo_11_02.c }
program Arvore_Binaria(Input,Output);
{ Estrutura de dados da rvore binria }
type
	{ item }
	Item = record
		isbn: integer;
		Autor: string[50];
		Titulo: string[100];				
	end;
	{ ponteiro para nodo }
	Ap_Nodo = ^Nodo; 
	{ estrutura nodo }
	Nodo = record
		Livro: Item;
		Esquerda, Direita: Ap_Nodo;
	end;
	{ estrutura arvore }
	Arvore = record
		Raiz: Ap_Nodo;
		tamanho: integer;
	end;

{ operaes em rvores }

{ operaes sobre rvores binrias
inicializao }
procedure Iniciacao(var Arv: Arvore);
begin
	Arv.Raiz := nil;
end;

{ insero }
function Insercao(var Arv: Arvore; Novo_Livro: Item): boolean;
{ procedimento auxiliar para insero }
function Insercao_Nodo(var Nodo1: Ap_Nodo; Novo_Livro: Item): boolean;
begin
	{ J est no ponto de insero }
	if (Nodo1 = nil ) then
	begin
		new(Nodo1);

		Nodo1^.Livro.isbn := Novo_Livro.isbn;
		Nodo1^.Livro.Autor := Novo_Livro.Autor;
		Nodo1^.Livro.Titulo := Novo_Livro.Titulo;
		Nodo1^.Esquerda := nil;
		Nodo1^.Direita := nil;

		Insercao_Nodo := true;
	end
	else
		{ insere o item  esquerda do nodo atual}
		if (Novo_Livro.isbn < Nodo1^.Livro.isbn) then
			Insercao_Nodo := Insercao_Nodo(Nodo1^.Esquerda, Novo_Livro)
		else
			{ insere o item  direita do nodo atual }
			if (Novo_Livro.isbn > Nodo1^.Livro.isbn) then
				Insercao_Nodo := Insercao_Nodo(Nodo1^.Direita, Novo_Livro)
			else 
			{ Registro repetido}
				Insercao_Nodo := false;
end;

begin
	{ chama o procedimento auxiliar para inserir na arvore}
	Insercao := Insercao_Nodo(Arv.Raiz, Novo_Livro);
end;

{ busca }
function Busca(var Arv: Arvore; chave:integer; var Livro: Item): boolean;
{ busca - procedimento auxiliar }
function Busca_Nodo(Nodo1: Ap_Nodo; chave:integer; var Livro: Item): boolean;
begin
	{ Elemento No Encontrado }
	if (Nodo1 = nil) then 
		Busca_Nodo := false
	else
		{ Se o ISBN for maior que o do nodo atual, continua a busca 
		  direita desse nodo}
		if (chave > Nodo1^.Livro.isbn) then
			Busca_Nodo := Busca_Nodo(Nodo1^.Direita, chave, Livro)
		else
			{ Se o ISBN for menor que o do nodo atual, continua a busca 
			  esquerda desse nodo }
			if (chave < Nodo1^.Livro.isbn) then
				Busca_Nodo := Busca_Nodo(Nodo1^.Esquerda, chave, Livro)
			else 
			begin
				Livro.isbn := Nodo1^.Livro.isbn;
				Livro.Autor := Nodo1^.Livro.Autor;
				Livro.Titulo := Nodo1^.Livro.Titulo;
				Busca_Nodo := true;
			end
end;

begin
	Busca := Busca_Nodo(Arv.Raiz, chave, Livro)
end;

{ remoo }
function Remove(var Arv:Arvore; chave: integer): boolean;
{ funo utilizada na remoo de nodo } 
procedure Busca_Nova_Raiz(Ap_Copia: Ap_Nodo; var Ap_Arvore: Ap_Nodo);
var
	Ap_Remove: Ap_Nodo;
begin
	{ Ap_Cpia aponta para o n a ser removido }
	if (Ap_Arvore^.Esquerda <> nil) then
		Busca_Nova_Raiz(Ap_Copia, Ap_Arvore^.Esquerda)
	else 
	begin
		{ Ao invs de remover, copiamos o contedo da nova raiz no n
		que seria removido }
		{Ap_Copia = (*Ap_Arvore);}
		
		Ap_Remove := Ap_Arvore;		

		{ Raiz substituta j copiada para sua nova posio }
		Ap_Copia^.Livro.isbn := Ap_Remove^.Livro.isbn;
		Ap_Copia^.Livro.Autor := Ap_Remove^.Livro.Autor;
		Ap_Copia^.Livro.Titulo := Ap_Remove^.Livro.Titulo;
		
		{ ligao do filho do n liberado com o seu pai. Ap_rvore foi
		passado por referncia }
		Ap_Arvore := Ap_Arvore^.Direita;
		
		dispose(Ap_Remove);
	end
end;

{ procedimento auxiliar para remoo do nodo}
function Remove_Nodo(Nodo1: Ap_Nodo; chave:integer): boolean;
var
	Ap_Aux: Ap_Nodo;
	
begin
	{ Elemento No Encontrado }
	if (Nodo1 = nil) then
		Remove_Nodo := false
	else
	begin
		{ se o ISBN for maior que o do nodo atual, continua a busca 
		direita desse nodo }
		if (chave > Nodo1^.Livro.isbn) then
			Remove_Nodo := Remove_Nodo(Nodo1^.Direita, chave)
		else
			{ se o ISBN for maior que o do nodo atual, continua a
			busca  direita desse nodo }
			if (chave < Nodo1^.Livro.isbn) then
				Remove_Nodo := Remove_Nodo(Nodo1^.Esquerda, chave)
			else { Elemento encontrado }
			begin
				Ap_Aux := Nodo1;
				{ Tipos 1 e 2 }
				if (Nodo1^.Direita = nil) then
				begin
					Nodo1 := Nodo1^.Esquerda;
					dispose(Ap_Aux);
				end
				else
					{Tipos 1 e 2}
					if (Nodo1^.Esquerda = nil) then
					begin
						Nodo1 := Nodo1^.Direita;
						dispose(Ap_Aux);
					end
					else { Tipo 3 }
						Busca_Nova_Raiz(Nodo1, Nodo1^.Direita);
			end;
			Remove_Nodo := true;
		end;
end;

begin
	{ chama o procedimento auxiliar }
	Remove := Remove_Nodo(Arv.Raiz, chave)
end;


{ percorre a rvore em percurso ps-ordem, apagando as sub-rvores e
depois apagando o n. }
procedure Apaga_Nodos(Nodo1: Ap_Nodo);
begin
	if (Nodo1 <> nil) then
	begin
		Apaga_Nodos(Nodo1^.Esquerda);
		Apaga_Nodos(Nodo1^.Direita);
		dispose(Nodo1);
	end
end;

{ trmino }
procedure Termino(Arv: Arvore);
begin
	Apaga_Nodos(Arv.Raiz)
end;

{ funo para atualizar um registro em uma rvore }
procedure Atualiza_Registro(var Arv: Arvore; Livro: Item);
var
	Nodo1: Ap_Nodo;
 	achou: boolean;
begin
	if (Arv.Raiz = nil) then 
	begin
		write('A rvore est vazia!');
		exit;
	end;
	{ A varivel "achou" indica se o elemento foi encontrado na rvore
	ou no. }
	achou := false;
	Nodo1 := Arv.Raiz;
	
	{Enquanto no achou o elemento ou no chegamos ao fundo da rvore}
	while (not achou) and (Nodo1 <> nil) do
	begin
		if (Livro.isbn = Nodo1^.Livro.isbn) then
			{ Achamos o elemento na raiz da subrvore atual. }
			achou := true
		else
			{ Item est  esquerda da raiz da subrvore atual.} 
			if (Livro.isbn < Nodo1^.Livro.isbn) then
				Nodo1 := Nodo1^.Esquerda
			else 
				Nodo1 := Nodo1^.Direita
	end;
	
	if (not achou) then
	begin
		writeln('No foi encontrado tal registro na rvore!');
		exit;
	end;
	
	{ Como Nodo1  um ponteiro para o n correto na rvore, basta
	atualizar as informaes diretamente nele que elas constaro na
	rvore. }
	Nodo1^.Livro.Autor := Livro.Autor;
	Nodo1^.Livro.Titulo := Livro.Titulo;
end;

var
	Arvore1: Arvore;
	Livro: Item;
begin
	{ Dados de teste }
	Livro.isbn := 1234;
	Livro.Autor := 'Jose';
	Livro.Titulo := 'Livro do Jose';
	
	{ inicializa a rvore }
	Iniciacao(Arvore1);

	{ insere o elemento na rvore }
	if Insercao(Arvore1, Livro) then
		writeln('Insercao bem-sucedida')
	else
		writeln('Insercao nao foi bem-sucedida');

	{ imprime os valores originais }
	write(Arvore1.Raiz^.Livro.isbn, ', ');
	write(Arvore1.Raiz^.Livro.Autor, ', ');
	writeln(Arvore1.Raiz^.Livro.Titulo);

	{ troca os valores do livro }
	Livro.Autor := 'Joao';
	Livro.Titulo := 'Livro do Joao';
	
	Atualiza_Registro(Arvore1, Livro);

	{ imprime os valores depois da substituio }
	write(Arvore1.Raiz^.Livro.isbn, ', ');
	write(Arvore1.Raiz^.Livro.Autor, ', ');
	writeln(Arvore1.Raiz^.Livro.Titulo);
			
	{ apaga a rvore }
	Termino(Arvore1);
end.
